/*
 * Proyecto Final: Estructura de Datos
 * Diccionario
 * JACE - JDSM - ADUA - AAVJ
 */
package Vista;

import Controlador.dao.PersonaDao;
import javax.swing.JOptionPane;


public class FrmRegistrarUsuario extends javax.swing.JFrame {

    PersonaDao personaDao = new PersonaDao();

    /**
     * Creates new form RegistrarUsuario
     */
    public FrmRegistrarUsuario() {
        initComponents();
    }
    
    /**
     * Permite guardar a cada usuario que se registre
     */
    public void guardar() {
        personaDao.getPersona().setNombre(txtRegistroNombre.getText());
        personaDao.getPersona().setRol(txtRegistroRol.getText());
        personaDao.getPersona().getCuenta().setUser(txtRegistroUsuario.getText());
        personaDao.getPersona().getCuenta().setClave(txtContrasenia.getText());
        if (txtContrasenia.getText().equals(txtConfirmarContrasenia.getText())) {
            if (personaDao.getPersona().getId() == null) {
                if (personaDao.guardar()) {
                    JOptionPane.showMessageDialog(this, "Se ha registrado correctamente");
                    this.dispose();
                } else {
                    JOptionPane.showMessageDialog(this, "No registrado");
                }
            }
        } else {
            JOptionPane.showMessageDialog(this, "La confirmación de contraseña no es igual", "Alerta", JOptionPane.WARNING_MESSAGE);
        } 
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panelRegistrarse = new javax.swing.JPanel();
        lblUsuario = new javax.swing.JLabel();
        lblClave = new javax.swing.JLabel();
        txtRegistroRol = new javax.swing.JTextField();
        btnRegistrarUsuario = new javax.swing.JButton();
        lblTitulo = new javax.swing.JLabel();
        lblConfirmarClave = new javax.swing.JLabel();
        lblIconoNuevoUsuario = new javax.swing.JLabel();
        txtContrasenia = new javax.swing.JPasswordField();
        txtConfirmarContrasenia = new javax.swing.JPasswordField();
        lblUsuario1 = new javax.swing.JLabel();
        txtRegistroUsuario = new javax.swing.JTextField();
        lblUsuario2 = new javax.swing.JLabel();
        txtRegistroNombre = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(null);

        panelRegistrarse.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        panelRegistrarse.setLayout(null);

        lblUsuario.setFont(new java.awt.Font("Tempus Sans ITC", 1, 12)); // NOI18N
        lblUsuario.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblUsuario.setText("Rol:");
        panelRegistrarse.add(lblUsuario);
        lblUsuario.setBounds(40, 140, 120, 17);

        lblClave.setFont(new java.awt.Font("Tempus Sans ITC", 1, 12)); // NOI18N
        lblClave.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblClave.setText("Contraseña:");
        panelRegistrarse.add(lblClave);
        lblClave.setBounds(30, 220, 130, 17);

        txtRegistroRol.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        txtRegistroRol.setText("Usuario");
        txtRegistroRol.setEnabled(false);
        panelRegistrarse.add(txtRegistroRol);
        txtRegistroRol.setBounds(170, 130, 190, 30);

        btnRegistrarUsuario.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/icono_registrarse.png"))); // NOI18N
        btnRegistrarUsuario.setText("Registrar");
        btnRegistrarUsuario.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RegistrarNuevoUsuario(evt);
            }
        });
        panelRegistrarse.add(btnRegistrarUsuario);
        btnRegistrarUsuario.setBounds(250, 340, 110, 30);

        lblTitulo.setFont(new java.awt.Font("Tempus Sans ITC", 1, 36)); // NOI18N
        lblTitulo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTitulo.setText("REGISTRARSE");
        panelRegistrarse.add(lblTitulo);
        lblTitulo.setBounds(0, 20, 270, 50);

        lblConfirmarClave.setFont(new java.awt.Font("Tempus Sans ITC", 1, 12)); // NOI18N
        lblConfirmarClave.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblConfirmarClave.setText("Confirme Contraseña:");
        panelRegistrarse.add(lblConfirmarClave);
        lblConfirmarClave.setBounds(30, 260, 130, 17);

        lblIconoNuevoUsuario.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/icono_nuevoUsuario.png"))); // NOI18N
        panelRegistrarse.add(lblIconoNuevoUsuario);
        lblIconoNuevoUsuario.setBounds(300, 10, 64, 70);
        panelRegistrarse.add(txtContrasenia);
        txtContrasenia.setBounds(170, 210, 190, 30);
        panelRegistrarse.add(txtConfirmarContrasenia);
        txtConfirmarContrasenia.setBounds(170, 250, 190, 30);

        lblUsuario1.setFont(new java.awt.Font("Tempus Sans ITC", 1, 12)); // NOI18N
        lblUsuario1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblUsuario1.setText("Usuario:");
        panelRegistrarse.add(lblUsuario1);
        lblUsuario1.setBounds(40, 180, 120, 17);

        txtRegistroUsuario.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        panelRegistrarse.add(txtRegistroUsuario);
        txtRegistroUsuario.setBounds(170, 170, 190, 30);

        lblUsuario2.setFont(new java.awt.Font("Tempus Sans ITC", 1, 12)); // NOI18N
        lblUsuario2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblUsuario2.setText("Nombre y Apellido:");
        panelRegistrarse.add(lblUsuario2);
        lblUsuario2.setBounds(40, 100, 120, 17);

        txtRegistroNombre.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        txtRegistroNombre.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtRegistroNombreKeyTyped(evt);
            }
        });
        panelRegistrarse.add(txtRegistroNombre);
        txtRegistroNombre.setBounds(170, 90, 190, 30);

        getContentPane().add(panelRegistrarse);
        panelRegistrarse.setBounds(0, 0, 400, 400);

        setSize(new java.awt.Dimension(416, 434));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void RegistrarNuevoUsuario(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RegistrarNuevoUsuario
        if (txtRegistroNombre.getText().trim().length() > 0 && txtRegistroUsuario.getText().trim().length() > 0) {
            if (!personaDao.UsuarioRepetido(txtRegistroUsuario.getText())) {
                guardar();
            } else {
                JOptionPane.showMessageDialog(this, "El nombre de usuario ya está en uso :D", "Alerta", JOptionPane.WARNING_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(this, "LLene todos los campos", "Alerta", JOptionPane.WARNING_MESSAGE);
        }
    }//GEN-LAST:event_RegistrarNuevoUsuario

    private void txtRegistroNombreKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtRegistroNombreKeyTyped
        char validar = evt.getKeyChar();
        if (Character.isDigit(validar)) {
            getToolkit().beep();
            evt.consume();
            JOptionPane.showMessageDialog(rootPane, "Ingrese solo letras", "Alerta", JOptionPane.WARNING_MESSAGE);
        }
    }//GEN-LAST:event_txtRegistroNombreKeyTyped

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrmRegistrarUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrmRegistrarUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrmRegistrarUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrmRegistrarUsuario.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrmRegistrarUsuario().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnRegistrarUsuario;
    private javax.swing.JLabel lblClave;
    private javax.swing.JLabel lblConfirmarClave;
    private javax.swing.JLabel lblIconoNuevoUsuario;
    private javax.swing.JLabel lblTitulo;
    private javax.swing.JLabel lblUsuario;
    private javax.swing.JLabel lblUsuario1;
    private javax.swing.JLabel lblUsuario2;
    private javax.swing.JPanel panelRegistrarse;
    private javax.swing.JPasswordField txtConfirmarContrasenia;
    private javax.swing.JPasswordField txtContrasenia;
    private javax.swing.JTextField txtRegistroNombre;
    private javax.swing.JTextField txtRegistroRol;
    private javax.swing.JTextField txtRegistroUsuario;
    // End of variables declaration//GEN-END:variables
}
